public class BubbleSort implements Sorter {

  private static enum Order { ASCENDING, DESCENDING, RANDOM };
  
  private Order order;
  
  public BubbleSort() {
    this(Order.ASCENDING);
  }
  
  public BubbleSort(Order order) {
    this.order = order;
  }
  
  public void sort(Comparable[] data) {
    boolean swapped;
    do {
      swapped = false;
      for (int i = 0; i < data.length-1; i++) {
        if ((order == Order.ASCENDING && data[i].compareTo(data[i+1]) > 0)
             || (order == Order.DESCENDING && data[i].compareTo(data[i+1]) < 0)) {
          swap(data, i, i+1);
          swapped = true;
        }
      }
    } while (swapped);
  }
  
  private void swap(Comparable[] data, int index1, int index2) {
    Comparable dummy = data[index1];
    data[index1] = data[index2];
    data[index2] = dummy;
  }
}